%define pyname  Shiboken2

%define qttarballdir pyside-setup-opensource-src

Name:           shiboken2
Version:        5.15.6
Release:        %mkrel 2
License:        LGPLv2+
Summary:        Creates the PySide2 bindings source files for Qt5
Group:          Development/Libraries
URL:            https://wiki.qt.io/Qt_for_Python
Source0:        http://download.qt.io/official_releases/QtForPython/shiboken2/PySide2-%{version}-src/%{qttarballdir}-%{version}.tar.xz
Patch0:         shiboken2-5.12.2-python3-linking.patch

BuildRequires:  kf5-macros
BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5Network)
BuildRequires:  pkgconfig(Qt5Xml)
BuildRequires:  pkgconfig(Qt5XmlPatterns)

BuildRequires:  pkgconfig(python3)
BuildRequires:  python3-setuptools
BuildRequires:  python3-sphinx
BuildRequires:  python3-numpy-devel
BuildRequires:  pkgconfig(libxslt)
BuildRequires:  pkgconfig(libxml-2.0)

BuildRequires:  clang-devel
BuildRequires:  llvm-devel

Requires:       python3-%{name} = %{version}-%{release}

### Python 3

%description
The Shiboken2 Generator (A.K.A. shiboken) is the plugin that creates the
PySide2 bindings source files from Qt5 headers and auxiliary files
(typesystems, global.h and glue files).

%files
%{_bindir}/%{name}
%{_bindir}/shiboken_tool.py

#------------------------------------------------------------------------------

%package -n     python3-%{name}
Summary:        Creates the Python3 PySide2 bindings source files for Qt5
Group:          Development/Libraries

%description -n python3-%{name}
The Shiboken2 Generator (A.K.A. shiboken) is the plugin that creates the
Python3 PySide2 bindings source files from Qt5 headers and auxiliary files
(typesystems, global.h and glue files).

%files -n python3-%{name}
%{python3_sitearch}/%{name}/
%{python3_sitearch}/%{name}_generator/

#------------------------------------------------------------------------------

%define py3major   5.15
%define py3libname %mklibname %{name}-python%{python3_version}_ %{py3major}

%package -n     %{py3libname}
Summary:        Shiboken2 Generator core library
Group:          System/Libraries
Obsoletes:      lib64shiboken2-python3.6_5.12
Provides:       lib64shiboken2-python3.6_5.12 = %version-%release

%description -n %{py3libname}
Python3 Shiboken2 Generator core library.

%files -n %{py3libname}
%{_libdir}/lib%{name}.cpython-%{python3_version_nodots}*.so.%{py3major}*

#------------------------------------------------------------------------------

%define py3libname_dev %mklibname %{name}-python%{python3_version} -d

%package -n     %{py3libname_dev}
Summary:        Development files for Python3 Shiboken2 Generator
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       %{py3libname} = %{version}-%{release}
Requires:       python3-%{name} = %{version}-%{release}
Requires:       clang-devel
Requires:       llvm-devel
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{py3libname_dev}
Development files for Python3 Shiboken2 Generator.

%files -n %{py3libname_dev}
%{_includedir}/%{name}/
%{_libdir}/lib%{name}.cpython-%{python3_version_nodots}*.so
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/cmake/%{pyname}-%{version}/

### End of Python 3
#------------------------------------------------------------------------------

%prep
%setup -q -n %{qttarballdir}-%{version}
%autopatch -p1

%build
### Python 3
pushd sources/shiboken2
%cmake -DBUILD_TESTS=OFF \
       -DUSE_PYTHON_VERSION=3
%make_build
popd

%install
### Python 3
%make_install -C sources/shiboken2/build

# Python shebang
pathfix.py -pni "%{__python3} %{py3_shbang_opts}" %{buildroot}%{_bindir}/*


%changelog
* Thu Oct 26 2023 tex - 5.15.6-2pclos2023
- rebuild against updates

* Sun Sep 18 2022 tex - 5.15.6-1pclos2022
- new version

* Thu Aug 11 2022 tex - 5.15.2.1-2pclos2022
- rebuild against updates

* Tue Jul 26 2022 TerryN <terryn94 at gmail.com> 5.15.2.1-1pclos2022
- update and rebuild for python 3.10

* Wed Aug 04 2021 tex - 5.15.2-2pclos2021
- rebuild against new llvm and clang

* Fri Nov 20 2020 tex - 5.15.2-1pclos2020
- new version

* Sun Sep 13 2020 tex - 5.15.1-1pclos2020
- new version

* Tue Jul 07 2020 tex - 5.15.0-3pclos2020
- rebuild against updates

* Sun Jun 14 2020 tex - 5.15.0-2pclos2020
- try to fix updating

* Wed Jun 10 2020 tex - 5.15.0-1pclos2020
- new
